﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_underscore_case
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Convert from TitleCase to underscore_case.
        private void btnConvert_Click(object sender, EventArgs e)
        {
            StringBuilder sb = new StringBuilder();
            bool to_upper = chkUpperCase.Checked;
            bool start_of_word = true;
            foreach (char ch in txtTitleCase.Text)
            {
                if (char.IsUpper(ch))
                    if (!start_of_word) sb.Append("_");

                if (to_upper)
                    sb.Append(ch.ToString().ToUpper());
                else
                    sb.Append(ch.ToString().ToLower());

                start_of_word = char.IsWhiteSpace(ch);
            }
            txtUnderscoreCase.Text = sb.ToString();
        }
    }
}
